import Live
from _Framework.SessionComponent import SessionComponent
from _Framework.ButtonElement import ButtonElement
from _Framework.SubjectSlot import subject_slot_group

from LiveZoneScene import LiveZoneScene
from fingerboardcodes import FUNC_BLINKOFF, FUNC_BRIGHT

import diagnostic

class LiveZone(SessionComponent):
	"""Represents the area of a Live session controlled from the Ztar fingerboard."""
        scene_component_type = LiveZoneScene
	
        def _update_stop_track_clip_buttons(self):
                if self.is_enabled():
                        sendValue = self._stop_clip_value
                else:
                        sendValue = 0

                if self._stop_track_clip_buttons:
                        for button in self._stop_track_clip_buttons:
                                button.send_value(sendValue)
                                button.send_function(FUNC_BLINKOFF)
                                button.send_function(FUNC_BRIGHT)

        def _update_stop_all_clips_button(self):
                if self.is_enabled():
                        sendValue = self._stop_clip_value
                else:
                        sendValue = 0

                if self._stop_all_button:
                        self._stop_all_button.send_value(sendValue)
                        self._stop_all_button.send_function(FUNC_BLINKOFF)
                        self._stop_all_button.send_function(FUNC_BRIGHT)

        @subject_slot_group('fired_slot_index')
	def _on_fired_slot_index_changed(self, index):
		"""Override to keep the stop track buttons lit. By default, the Live framework calls turn_off() on the stop
clips button for a track when a track for that clip is played."""
		if self.is_enabled() and self._stop_track_clip_buttons != None:
			self._stop_track_clip_buttons[index].send_value(self._stop_clip_value)

